"""
Copyright (c) 2024 zhbaor <zhbaor@zhaozuohong.vip>

This file is part of mower-ng (https://git.zhaozuohong.vip/mower-ng/mower-ng).

Mower-ng is free software: you may copy, redistribute and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation, version 3 or later.

This file is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
"""

from datetime import datetime

from .sign_in import SignIn


class SignInManager:
    solver_name = "签到管理器"
    scheduler_stop_time = None

    def run(self) -> bool:
        result = True
        if datetime.now() < datetime(2025, 1, 8):
            solver_list = [SignIn()]
            for solver in solver_list:
                solver.scheduler_stop_time = self.scheduler_stop_time
                result = result and solver.run()
        return result
